/*
 * MSP430F1_2_4xxx_mask.cpp
 *
 * Definition of mask for MSP430F1_2_4xx devices.
 *
 * Copyright (C) 2011 Texas Instruments Incorporated - http://www.ti.com/ 
 * 
 * 
 *  Redistribution and use in source and binary forms, with or without 
 *  modification, are permitted provided that the following conditions 
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright 
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the 
 *    documentation and/or other materials provided with the   
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                                                                                                                                                                                                                                                                                                         
 */

#include "MSP430F1_2_4xxx_masks.h"


namespace TI { namespace DLL430 { namespace TemplateDeviceDb{
namespace Memory {
	const uint8_t sfrMaskData_33ff13ffffff[SFR_MASK_SIZE] = {0x33, 0xff, 0x13, 0xff, 0xff, 0xff};
	const uint8_t sfrMaskData_33ff1fffffff[SFR_MASK_SIZE] = {0x33, 0xff, 0x1f, 0xff, 0xff, 0xff};
	const uint8_t sfrMaskData_f330d330c030[SFR_MASK_SIZE] = {0xf3, 0x30, 0xd3, 0x30, 0xc0, 0x30};
	const uint8_t sfrMaskData_33801380ffff[SFR_MASK_SIZE] = {0x33, 0x80, 0x13, 0x80, 0xff, 0xff};
	const uint8_t sfrMaskData_33031303ff03[SFR_MASK_SIZE] = {0x33, 0x03, 0x13, 0x03, 0xff, 0x03};
	const uint8_t sfrMaskData_f380d380c0ff[SFR_MASK_SIZE] = {0xf3, 0x80, 0xd3, 0x80, 0xc0, 0xff};
	const uint8_t sfrMaskData_f3b0d3b0c030[SFR_MASK_SIZE] = {0xf3, 0xb0, 0xd3, 0xb0, 0xc0, 0x30};
	const uint8_t sfrMaskData_33801f80ffff[SFR_MASK_SIZE] = {0x33, 0x80, 0x1f, 0x80, 0xff, 0xff};
	const uint8_t sfrMaskData_338f1f1fffff[SFR_MASK_SIZE] = {0x33, 0x8f, 0x1f, 0x1f, 0xff, 0xff};
	const uint8_t sfrMaskData_338f1f8fffff[SFR_MASK_SIZE] = {0x33, 0x8f, 0x1f, 0x8f, 0xff, 0xff};
	const uint8_t sfrMaskData_33bf13bfff30[SFR_MASK_SIZE] = {0x33, 0xbf, 0x13, 0xbf, 0xff, 0x30};
	const uint8_t sfrMaskData_330f1f0fffff[SFR_MASK_SIZE] = {0x33, 0x0f, 0x1f, 0x0f, 0xff, 0xff};
	const uint8_t sfrMaskData_f3ffd3ffc0ff[SFR_MASK_SIZE] = {0xf3, 0xff, 0xd3, 0xff, 0xc0, 0xff};
	const uint8_t sfrMaskData_f3ffdfffc0ff[SFR_MASK_SIZE] = {0xf3, 0xff, 0xdf, 0xff, 0xc0, 0xff};
} //namespace Memory
} //namespace TemplateDeviceDb
}//namespace DLL430
}//namespace TI
